<?php
require_once __DIR__ . '/../vendor/autoload.php';
require_once __DIR__ . '/../config/config.php';
use App\AppCreator;
use App\Router\Middleware\LoggingMiddleware;
use App\Router\Request\RequestFactory;
use Controllers\ArgumentControllerResolver;
use Controllers\IArgumentResolver;
$appFactory = new AppCreator();
$appFactory->registerService(IArgumentResolver::class,ArgumentControllerResolver::class);
// $appFactory->registerService('twig',);

// // Connexion à la base de données
// $databaseContext = DatabaseContext::getInstance();
$appFactory->AddControllers();
$app = $appFactory->create();
$app->use(new LoggingMiddleware());
// $app->addHttpClient(HttpClient::class);
// je veux pas faire sa pour load les controller avec les anotation 
$app->mapControllers();

$app->run(RequestFactory::createFromGlobals());
