<?php

declare(strict_types = 1);

namespace App\Enums;
enum HttpMethod: string {
    case Get = 'GET';
    case Post = 'POST';
    case Put = 'PUT';
    case Head = 'HEAD';

    case Patch = "PATCH";

    case Delete = 'Delete';
    public static function values()
    {
        return [
            self::Get,
            self::Post,
            self::Put,
            self::Delete,
            self::Head,
            self::Patch,
            // Add more HTTP methods as needed
        ];
    }
}

