<?php

declare(strict_types = 1);

namespace App\Attributes;

use App\Enums\HttpMethod;

#[\Attribute(Attribute::TARGET_METHOD|Attribute::IS_REPEATABLE)]
class Get extends Route
{
    public function __construct( 
    private string|array $path,
    private ?string $name = null)
    {
        parent::__construct($path,$name,HttpMethod::Post);
    }
}