<?php
namespace Database;

use Model\User;
use Repository\IUserRepository;
use Database\DbContext;

class UserRepository implements IUserRepository {
    private readonly DbManager $parent;

    public function __construct(DbManager $dbContext) {
        $this->parent = $dbContext;
    }

    public function getItemById(int $id): ?User {
        throw new NotImplementedException();
    }
    public function GetItemByName(string $substring, int $index, int $count, ?string $orderingPropertyName = null, bool $descending = false){
        throw new NotImplementedException();
    }

    public function getItemByEmail(string $email): ?User {
        throw new NotImplementedException();

    }

    public function getNbItems(): int {
        throw new NotImplementedException();
    }

    public function getItems(int $index, int $count, ?string $orderingPropertyName = null, bool $descending = false): array {
        throw new NotImplementedException();
    }

    public function getItemsByName(string $substring, int $index, int $count, ?string $orderingPropertyName = null, bool $descending = false): array {
        throw new NotImplementedException();
    }

    public function addItem(User $user): ?User {
        // Add a new user to the database
        $userEntity = $this->parent->context->userGateWay->addUser($user->toEntity());
        $this->parent->dbContext->userGateWay->saveChanges();

        return $userEntity->ToModel(); 
    }

    public function updateItem(User $oldUser, User $newUser): void {
        throw new NotImplementedException();
    }

    public function deleteItem(User $user): bool {
        // should use name and other things to equals
        $usertoDelete = $this->parent->context->userGateWay->GetItemsByName($user->getNom());
        // Where(c => c.Name == item.Name).First();
        if ($usertoDelete != null)
        {
            $deleted = $this->dbContext->userGateWay->Remove($usertoDelete);
            $this->parent->dbContext->saveChanges();
            return true;
        }
        return false;
    }

}

?>
